/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */
#ifndef VBJAE_H_
#define	VBJAE_H_

/*
 * 
 * 
 *  "vbJaEngine"
 * 
 * 
*/


// include basic virtual boy library
#include <libgccvb.h>


// include game's specific configuration
#include "config.h"

// include engine's global macros
#include "src/Constants.h"

// include engine's classes
#include "src/Game.h"
#include "src/Actor.h"
#include "src/Background.h"
#include "src/TextureManager.h"
#include "src/CharGroup.h"
#include "src/CharSetManager.h"
#include "src/Clock.h"
#include "src/CollisionManager.h"
#include "src/Image.h"
#include "src/Entity.h"
#include "src/InGameEntity.h"
#include "src/Error.h"
#include "src/AnimatedSprite.h"
#include "src/FrameRate.h"
#include "src/Globals.h"
#include "src/MemoryPool.h"
#include "src/MessageDispatcher.h"
#include "src/MiscStructs.h"
#include "src/Optics.h"
#include "src/Object.h"
#include "src/ParamTableManager.h"
#include "src/Printing.h"
#include "src/StateMachine.h"
#include "src/Scroll.h"
#include "src/Texture.h"
#include "src/UserObjects.h"
#include "src/VirtualList.h"


#endif
