/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef DEBUG_H_
#define DEBUG_H_


/*---------------------------------INCLUDES--------------------------------*/
/*--------------------------------STRUCTURES-------------------------------*/
/*---------------------------------FUNCTIONS-------------------------------*/
//print debug mode's navigation information
void printNavigateInstructions(){
	vbPrint(_textBgMap,16,27, "<-L Navigate R->", 0);
		
}

//engine's capabilities
void engineCapabilityInformation(){
	int row=2,colText=1;
	int total=0; 				

	vbPrint(_textBgMap,13,0, "ENGINE'S CAPABILITIES", 0);
	
	vbPrint(_textBgMap,colText,row++, "Dynamic Memory Allocation", 0);
	vbPrint(_textBgMap,colText,row++, "Transparent graphic memory handling", 0);
	vbPrint(_textBgMap,colText,row++, "Programmer's defined graphic strucutures", 0);	
	vbPrint(_textBgMap,colText,row++, "Programmer's defined text strucutures", 0);
	vbPrint(_textBgMap,colText,row++, "State transition handling", 0);
	vbPrint(_textBgMap,colText,row++, "Automatic H-Bias", 0);
	vbPrint(_textBgMap,colText,row++, "Lighting", 0);
	printNavigateInstructions();

}
//main information
void mainDebugInformation(){
	int row=2,colText=1,colSize=18,colBytes=19;
	int total=0; 				
	vbPrint(_textBgMap,13,0, "MAIN DEBUG INFORMATION", 0);
	//frame Rate
	vbPrint(_textBgMap,colText,row, "FPS:", 0);
	vbPrint(_textBgMap, colSize,row++, itoa(_frameRate.lastFps,10,4), 0);
	//next free world
	vbPrint(_textBgMap,colText,row, "World Free:", 0);
	vbPrint(_textBgMap, colSize,row++, itoa(_worldFree,10,2), 0);
	//text printing world	
	vbPrint(_textBgMap,colText,row, "Printing World: ", 0);
	vbPrint(_textBgMap, colSize,row++, itoa(_textWorld,10,2), 0);
	//print instructions	
	printNavigateInstructions();
}

//print common engine data's size
void printStructureSizes(){
	int row=2,colText=1,colSize=15,colBytes=19;
	int total=0;	
	vbPrint(_textBgMap,14,0, "2D STRUCTURES's SIZE", 0);
	//print mapCharacter size in bytes
	vbPrint(_textBgMap,colText,row, "MapCharacter:", 0);
	vbPrint(_textBgMap, colSize,row, itoa(sizeof(struct MapCharacter),10,3), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//print objCharacter size in bytes
	vbPrint(_textBgMap,colText,row, "ObjCharacter:", 0);
//	vbPrint(_textBgMap, colSize,row, itoa(sizeof(struct ObjCharacter),10,3), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//print scrollBG size in bytes	
	vbPrint(_textBgMap,colText,row, "ScrollBG: ", 0);
//	vbPrint(_textBgMap, colSize,row, itoa(sizeof(struct ScrollBgEntity),10,3), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//print maptext size in bytes	
	vbPrint(_textBgMap,colText,row, "MapText: ", 0);
//	vbPrint(_textBgMap, colSize,row, itoa(sizeof(struct MapTextBox),10,3), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	

	//print instructions
	printNavigateInstructions();

}

//print dynamic allocated data status
void printDynamicMemoryUsage(){
	int row=2,colText=1,colSize=28,colBytes=34;
	int total=0;	
	vbPrint(_textBgMap,14,0, "DYNAMIC MEMORY USAGE", 0);
	//total amount of dynamic memory 
	vbPrint(_textBgMap,colText,row, "Total Dynamic Memory:", 0);
	//vbPrint(_textBgMap,colSize,row, itoa((int)HEAPSIZE,10,5), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//amount of dynamic memory in use
	vbPrint(_textBgMap,colText,row, "Total Memory usage:", 0);
//	vbPrint(_textBgMap,colSize,row, itoa(HEAPSIZE-_heap.numBytes,10,5), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	

	//actual number of allocated objects
	vbPrint(_textBgMap,colText,row, "Allocated objects:", 0);
//	vbPrint(_textBgMap,colSize,row++, itoa(_heap.index,10,5), 0);

	
	//bytes used by Characters
	vbPrint(_textBgMap,colText,row, "MapCharacters's Mem usage:", 0);
	vbPrint(_textBgMap, colSize,row, itoa(getListSize(_gameWorld.mapCharacterList.head)*(sizeof(struct MapCharacter)),10,5), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//bytes used by objCharacters
/*	vbPrint(_textBgMap,colText,row, "ObjCharacter Mem usage:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(_characters.index*(sizeof(struct ObjCharacter)),10,5), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
*/	//bytes used by scrollBGs
	vbPrint(_textBgMap,colText,row, "ScrollBg Mem usage:", 0);
	//vbPrint(_textBgMap,colSize,row, itoa(getListSize(_gameWorld.scrollBgList.head)*(sizeof(struct ScrollBgEntity)),10,5), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//print instructions
	printNavigateInstructions();
}

void printStereoscopicParameters(){
	int row=2,colText=1,colSize=31,colBytes=35;
	int total=0;
	vbPrint(_textBgMap,12,0, "STEREOSCOPIC PARAMETERS", 0);
	//total amount of dynamic memory 
	vbPrint(_textBgMap,colText,row, "Interocular distance:", 0);
	vbPrint(_textBgMap, colSize,row++, itoa((int)_baseDistance,10,3), 0);
    //distance from the players view point to the screen (384)
	vbPrint(_textBgMap,colText,row, "Distance player-screen:", 0);
	vbPrint(_textBgMap, colSize,row, itoa(_distanceEyeScreen,10,3), 0);
	vbPrint(_textBgMap, colBytes,row++, "pixels", 0);
	//maximun distance from the screen to the infinite
	vbPrint(_textBgMap,colText,row, "Maximun view distance:", 0);
	vbPrint(_textBgMap, colSize,row, itoa(_maximunViewDistance,10,3), 0);
	vbPrint(_textBgMap, colBytes,row++, "pixels", 0);
	//horizontal View point center (192)
	vbPrint(_textBgMap,colText,row, "Horizontal View point center:", 0);
	vbPrint(_textBgMap, colSize,row++, itoa(_horizontalViewPointCenter,10,3), 0);
	//vertical View point center (112)  
	vbPrint(_textBgMap,colText,row, "Vertical View point center:", 0);
	vbPrint(_textBgMap, colSize,row++, itoa(_verticalViewPointCenter,10,3), 0);
	//print zero screen coordinate
	vbPrint(_textBgMap,colText,row, "Screen's Zero Coordinate:", 0);
	if(__ZZERO<0){
		vbPrint(_textBgMap, colSize-1,row, "-", 0);
		vbPrint(_textBgMap, colSize,row++, itoa(__ZZERO*(-1),10,3), 0);
	}
	else{		
		vbPrint(_textBgMap, colSize,row++, itoa(__ZZERO,10,3), 0);
	}

	//print minimun allowable z coordinate
	vbPrint(_textBgMap,colText,row, "Minimun Z Coordinate:", 0);
	if(__ZLOWLIMIT<0){
		vbPrint(_textBgMap, colSize-1,row, "-", 0);
		vbPrint(_textBgMap, colSize,row++, itoa(__ZLOWLIMIT*(-1),10,3), 0);
	}
	else{		
		vbPrint(_textBgMap, colSize,row++, itoa(__ZLOWLIMIT,10,3), 0);
	}
	//print instructions
	printNavigateInstructions();
}

//print total global variables memory allocation
void printGloblalMemoryUtilizationPag1(){
	int row=2,colText=1,colSize=30,colBytes=35;
	vbPrint(_textBgMap,12,0, "GLOBAL ALLOCATION MEMORY", 0);
	//_asciiChar
	vbPrint(_textBgMap,colText,row, "_asciiChar:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_asciiChar),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_baseDistance
	vbPrint(_textBgMap,colText,row, "_baseDistance:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_baseDistance),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//_bgMapMem
	vbPrint(_textBgMap,colText,row, "_bgMapMem:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_bgMapMem),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//_charMem
	vbPrint(_textBgMap,colText,row, "_charMem:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_charMem),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//_chars
	vbPrint(_textBgMap,colText,row, "_chars:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_chars),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//_charTable
	vbPrint(_textBgMap,colText,row, "_charTable:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_charTable),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//_currentGameState
	vbPrint(_textBgMap,colText,row, "_currentGameState:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_currentGameState),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//_currentPausedState
	vbPrint(_textBgMap,colText,row, "_currentPausedState:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_currentPauseState),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);	
	//_distanceEyeScreen
	vbPrint(_textBgMap,colText,row, "_distanceEyeScreen:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_distanceEyeScreen),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_entities
/*	vbPrint(_textBgMap,colText,row, "_entities:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_entities),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
*/	//_errorMessage
	vbPrint(_textBgMap,colText,row, "_errorMessage:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_errorMessage),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_frameRate
	vbPrint(_textBgMap,colText,row, "_frameRate:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_frameRate),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_gameState
	vbPrint(_textBgMap,colText,row, "_gameState:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_gameState),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_gameWorldsTable
	vbPrint(_textBgMap,colText,row, "_gameWorldsTable:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_gameWorldsTable),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_horizontalViewPointCenter
	vbPrint(_textBgMap,colText,row, "_horizontalViewPointCenter:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_horizontalViewPointCenter),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_mapCharactersLogicTable
	vbPrint(_textBgMap,colText,row, "_mapCharactersLogicTable:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_mapCharactersLogicTable),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_maps
/*	vbPrint(_textBgMap,colText,row, "_maps:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_maps),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
*/	//_mapTable
	vbPrint(_textBgMap,colText,row, "_mapTable:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_mapTable),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//print instructions
	printNavigateInstructions();
}
//print total global variables memory allocation
void printGloblalMemoryUtilizationPag2(){
	int row=2,colText=1,colSize=30,colBytes=35;
	int total=0;	
	total+=sizeof(_asciiChar);
	total+=sizeof(_baseDistance);	
	total+=sizeof(_bgMapMem);
	total+=sizeof(_charMem);	
	total+=sizeof(_chars);	
	total+=sizeof(_charTable);	
	total+=sizeof(_currentGameState);
	total+=sizeof(_currentPauseState);
	total+=sizeof(_distanceEyeScreen);
//	total+=sizeof(_entities);
	total+=sizeof(_errorMessage);
	total+=sizeof(_frameRate);
	total+=sizeof(_gameState);
	total+=sizeof(_gameWorldsTable);	
	total+=sizeof(_horizontalViewPointCenter);
	total+=sizeof(_mapCharactersLogicTable);	
//	total+=sizeof(_maps);
	total+=sizeof(_mapTable);
	total+=sizeof(_maximunViewDistance);	
	vbPrint(_textBgMap,12,0, "GLOBAL ALLOCATION MEMORY", 0);
	//_maximunViewDistance
	vbPrint(_textBgMap,colText,row, "_maximunViewDistance:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_maximunViewDistance),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//_objectMem
	vbPrint(_textBgMap,colText,row, "_objectMem:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_objectMem),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	total+=sizeof(_objectMem);
	//_objects
	vbPrint(_textBgMap,colText,row, "_objects:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_objects),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	total+=sizeof(_objects);	
	//_render
	vbPrint(_textBgMap,colText,row, "_render:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_render),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	total+=sizeof(_render);
	//_screenXpos
	vbPrint(_textBgMap,colText,row, "_screen X position:", 0);
	//vbPrint(_textBgMap,colSize,row, itoa(sizeof(_screenPosition.x),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	//total+=sizeof(_screenPosition);
	//_usedParamTable
	vbPrint(_textBgMap,colText,row, "_usedParamTable:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_usedParamTable),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	total+=sizeof(_usedParamTable);
	//_verticalViewPointCenter
	vbPrint(_textBgMap,colText,row, "_verticalViewPointCenter:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_verticalViewPointCenter),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	total+=sizeof(_verticalViewPointCenter);
	//_worldFree
	vbPrint(_textBgMap,colText,row, "_worldFree:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(sizeof(_worldFree),10,4), 0);
	vbPrint(_textBgMap,colBytes,row++, "bytes", 0);
	total+=sizeof(_worldFree);
	//TOTAL
	row+=2;
	vbPrint(_textBgMap,colText,row, "TOTAL:", 0);
	vbPrint(_textBgMap,colSize,row, itoa(total,10,4), 0);
	vbPrint(_textBgMap,colBytes,row, "bytes", 0);
	//print instructions
	printNavigateInstructions();	
}
extern void updateGameWorld(int);
extern void pauseScreen(int);

//debug main function
void debugScreen(int message){
	static void (*currentDebugState)()=mainDebugInformation;
	static int debugState=0;
	int previousDebugState=debugState;
	if(message & K_LT & _lastPressedKey) {
	   	if(debugState>0){
	       	debugState--;
	   	}        	
    }else{
    	if(message & K_RT &  _lastPressedKey){
    		if(debugState<5){
        		debugState++;
    		}
        }
    }
	
	if(previousDebugState!=debugState){
		clearBGMap(_textBgMap);
	}
	switch(debugState){
		case 0:
			currentDebugState=mainDebugInformation;
			break;
		case 1:
			currentDebugState=printStructureSizes;
			break;
		case 2:
			currentDebugState=printDynamicMemoryUsage;
			break;
		case 3:
			currentDebugState=printStereoscopicParameters;
			break;
		case 4:
			currentDebugState=printGloblalMemoryUtilizationPag1;
			break;
		case 5:
			currentDebugState=printGloblalMemoryUtilizationPag2;
			break;
	}	
	//execute current debug state
    currentDebugState();
    //clear pad's buffer
//    flushPad();
    //insert a delay (because of bad flusing pad handling)
//    delay(100);   
}	

#endif /*DEBUG_H_*/
