/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */
#ifndef VBJAE_H_
#define	VBJAE_H_

/*
 * 
 * 
 *  "vbJaEngine"
 * 
 * 
*/


// include basic virtual boy library
#include <libgccvb2/libgccvb.h>


// include game's specific configuration
#include "config.h"

// include engine's global macros
#include "src/Constants.h"

// include engine's classes
#include "src/Game.c"
#include "src/Actor.c"
#include "src/Background.c"
#include "src/TextureManager.c"
#include "src/CharGroup.c"
#include "src/CharSetManager.c"
#include "src/Clock.c"
#include "src/CollisionManager.c"
#include "src/Image.c"
#include "src/Entity.c"
#include "src/InGameEntity.c"
#include "src/Error.c"
#include "src/AnimatedSprite.c"
#include "src/FrameRate.c"
#include "src/Globals.c"
#include "src/MemoryPool.c"
#include "src/MessageDispatcher.c"
#include "src/MiscStructs.c"
#include "src/Optics.c"
#include "src/Object.c"
#include "src/ParamTableManager.c"
#include "src/Printing.c"
#include "src/StateMachine.c"
#include "src/Scroll.c"
#include "src/Texture.c"
#include "src/UserObjects.c"
#include "src/VirtualList.c"


#endif
