/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */
#ifndef BRIDGE_H_
#define BRIDGE_H_

/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												INCLUDES
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */


#include "../../macros.h"

/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 											CLASS'S DECLARATION
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */


#define Bridge_METHODS							\
	Background_METHODS;
	
	

#define Bridge_SET_VTABLE(ClassName)						\
	Background_SET_VTABLE(ClassName);
	

// A Decoration which represents a generic object inside a Stage
__CLASS(Bridge);

#define Bridge_ATTRIBUTES							\
													\
	/* it is derivated from */						\
	Background_ATTRIBUTES							\
													\
	/* over which direction can mario walk on it */	\
	s8 zDirection;



/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 											CLASS'S ROM DECLARATION
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */

// defines a Background in ROM memory
typedef const struct BridgeDefinition{

	// It has an InGameEntity at the beggining
	BackgroundDefinition backgroundDefinition;

	// the direction over which mario can walk on it
	s8 zDirection;
	
}BridgeDefinition;

/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 										PUBLIC INTERFACE
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */

Bridge Bridge_new(BridgeDefinition* bridgeDefinition, u8 inGameIndex);

//class's conctructor
void Bridge_constructor(Bridge this, BridgeDefinition* bridgeDefinition, int inGameIndex);

// class's conctructor
void Bridge_destructor(Bridge this);

// retrieve the direction
s8 Bridge_getDirection(Bridge this);

// set the direction
void Bridge_setDirection(Bridge this, s8 zDirection);

#endif /*BRIDGE_H_*/