/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#include <libgccvb2/libgccvb.h>
#include "chars.h"
#include "maps.h"

extern const u16 ASCII_CH[];

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition PVBCC_LEFT_TX = {
		
		// Chargroup
		{
				// chDefinition,				 
				PVBCC_CHARSET_LEFT,	
				
				// numChars,
				238,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		PVBCC_MAP_LEFT,
		
		// cols (max 48)
		48,
		
		// rows (max 28)
		28,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition PVBCC_RIGHT_TX = {
		
		// Chargroup
		{
				// chDefinition,				 
				PVBCC_CHARSET_RIGHT,	
				
				// numChars,
				235,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		PVBCC_MAP_RIGHT,
		
		// cols (max 48)
		48,
		
		// rows (max 28)
		28,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition PRECAUTION_TX = {
		// Chargroup
		{
				// chDefinition,				 
				PRECAUTION_CH,	
				
				// numChars,
				96,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		PRECAUTION_MP,
		
		// cols (max 48)
		48,
		
		// rows (max 28)
		28,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition PVB_LEFT_TX = {
		// Chargroup
		{
				// chDefinition,				 
				PVB_LEFT_CH,	
				
				// numChars,
				81,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		PVB_LEFT_MP,
		
		// cols (max 48)
		48,
		
		// rows (max 28)
		28,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition PVB_RIGHT_TX = {
		// Chargroup
		{
				// chDefinition,				 
				PVB_RIGHT_CH,	
				
				// numChars,
				81,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		PVB_RIGHT_MP,
		
		// cols (max 48)
		48,
		
		// rows (max 28)
		28,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition VBJAE_LEFT_TX = {
		// Chargroup
		{
				// chDefinition,				 
				VBJAE_LEFT_CH,	
				
				// numChars,
				97,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		VBJAE_LEFT_MP,
		
		// cols (max 48)
		19,
		
		// rows (max 28)
		11,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition VBJAE_RIGHT_TX = {
		// Chargroup
		{
				// chDefinition,				 
				VBJAE_RIGHT_CH,	
				
				// numChars,
				97,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		VBJAE_RIGHT_MP,
		
		// cols (max 48)
		19,
		
		// rows (max 28)
		11,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition FLOOR0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				FLOOR0_CH,	
				
				// numChars,
				10,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		FLOOR0_MP,
		
		// cols (max 48)
		28,
		
		// rows (max 28)
		4,
		
		//pallet number,
		1
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition FLOOR1_TX = {
		// Chargroup
		{
				// chDefinition,				 
				FLOOR1_CH,	
				
				// numChars,
				10,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		FLOOR1_MP,
		
		// cols (max 48)
		6,
		
		// rows (max 28)
		4,
		
		//pallet number,
		1
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition FLOOR2_TX = {
		// Chargroup
		{
				// chDefinition,				 
				FLOOR2_CH,	
				
				// numChars,
				11,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		FLOOR2_MP,
		
		// cols (max 48)
		14,
		
		// rows (max 28)
		12,
		
		//pallet number,
		1
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition MOUNT0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				MOUNT0_CH,	
				
				// numChars,
				5,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		MOUNT0_MP,
		
		// cols (max 48)
		2,
		
		// rows (max 28)
		3,
		
		//pallet number,
		1
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition BRIDGE0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				BRIDGE0_CH,	
				
				// numChars,
				6,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		BRIDGE0_MP,
		
		// cols (max 48)
		6,
		
		// rows (max 28)
		2,
		
		//pallet number,
		1
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition MOUNTS0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				MOUNTS0_CH,	
				
				// numChars,
				18,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		MOUNTS0_MP,
		
		// cols (max 48)
		12,
		
		// rows (max 28)
		8,
		
		//pallet number,
		1
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition JAPANARC_TX = {
		// Chargroup
		{
				// chDefinition,				 
				JAPANARC_CH,	
				
				// numChars,
				18,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		JAPANARC_MP,
		
		// cols (max 48)
		16,
		
		// rows (max 28)
		12,
		
		//pallet number,
		1
		
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition PIPE0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				PIPE0_CH,	
				
				// numChars,
				16,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		PIPE0_MP,
		
		// cols (max 48)
		4,
		
		// rows (max 28)
		5,
		
		//pallet number,
		1
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition PIPE1_TX = {
		// Chargroup
		{
				// chDefinition,				 
				PIPE1_CH,	
				
				// numChars,
				17,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		PIPE1_MP,
		
		// cols (max 48)
		7,
		
		// rows (max 28)
		4,
		
		//pallet number,
		1
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition WALL0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				WALL0_CH,	
				
				// numChars,
				9,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		WALL0_MP,
		
		// cols (max 48)
		4,
		
		// rows (max 28)
		3,
		
		//pallet number,
		1
};
 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition NORMALBLOCK_TX = {
		// Chargroup
		{
				// chDefinition,				 
				NORMALBLOCK_CH,	
				
				// numChars,
				4,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		NORMALBLOCK_MP,
		
		// cols (max 48)
		2,
		
		// rows (max 28)
		2,
		
		//pallet number,
		1
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition GOAL0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				GOAL0_CH,	
				
				// numChars,
				11,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		GOAL0_MP,
		
		// cols (max 48)
		16,
		
		// rows (max 28)
		24,
		
		//pallet number,
		1
};



//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition POLE0_TX = {
		// Chargroup
		{
				// chDefinition,				 
				POLE0_CH,	
				
				// numChars,
				4,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		POLE0_MP,
		
		// cols (max 48)
		2,
		
		// rows (max 28)
		13,
		
		//pallet number,
		1
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition GATE_TX = {
		// Chargroup
		{
				// chDefinition,				 
				GATE_CH,	
				
				// numChars,
				1,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		GATE_MP,
		
		// cols (max 48)
		2,
		
		// rows (max 28)
		2,
		
		//pallet number,
		0
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition MARIO_TITLE_LEFT_TX = {
		// Chargroup
		{
				// chDefinition,				 
				MARIO_TITLE_LEFT_CH,	
				
				// numChars,
				159,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		MARIO_TITLE_LEFT_MP,
		
		// cols (max 48)
		19,
		
		// rows (max 28)
		23,
		
		//pallet number,
		0
};

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition MARIO_TITLE_RIGHT_TX = {
		// Chargroup
		{
				// chDefinition,				 
				MARIO_TITLE_RIGHT_CH,	
				
				// numChars,
				160,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		MARIO_TITLE_RIGHT_MP,
		
		// cols (max 48)
		19,
		
		// rows (max 28)
		23,
		
		//pallet number,
		0
};




//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition TITLE_TX = {
		// Chargroup
		{
				// chDefinition,				 
				TITLE_CH,	
				
				// numChars,
				207,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		TITLE_MP,
		
		// cols (max 48)
		24,
		
		// rows (max 28)
		11,
		
		//pallet number,
		0
};
