/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */
#ifndef GAMEWORLD_H_
#define GAMEWORLD_H_


/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												INCLUDES
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */



/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 											CLASS'S DECLARATION
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */

// declare the virtual methods
#define GameWorld_METHODS								\
	State_METHODS;									

// declare the virtual methods which are redefined
#define GameWorld_SET_VTABLE(ClassName)						\
	State_SET_VTABLE(GameWorld)	


__CLASS(GameWorld);

#define GameWorld_ATTRIBUTES			\
										\
	/* inherits */						\
	State_ATTRIBUTES					\
										\
	/* a pointer to the game's stage */	\
	Stage stage;						\
										\
	/* raise when mario is dead */		\
	u8 marioIsDead: 1;					\
	u8 levelCleared: 1;					\
										\
	/* to allow moving the screen */	\
	u8 mode: 4;							\
	u32 lastTime;






/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 										PUBLIC INTERFACE
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */

// setup the init focus screen
GameWorld GameWorld_getInstance(void);

// mario is dead
void GameWorld_marioIsDead(GameWorld this);

// level completed
void GameWorld_levelCleared(GameWorld this);

// move the screen
void GameWorld_moveScreen(GameWorld this);

// get working mode
int GameWorld_getMode(GameWorld this);

#endif /*GAMEWORLD_H_*/
