/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */



/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												INCLUDES
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */


#include "KoopaAttack.h"
#include "KoopaWalking.h"
#include "Koopa.h"
#include "../mario/Mario.h"


/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												PROTOTYPES
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */


// class's constructor
static void KoopaAttack_constructor(KoopaAttack this);

// class's destructor
static void KoopaAttack_destructor(KoopaAttack this);

// state's enter
static void KoopaAttack_enter(KoopaAttack this, void* owner);

// state's execute
static void KoopaAttack_execute(KoopaAttack this, void* owner);

// state's enter
static void KoopaAttack_exit(KoopaAttack this, void* owner);

// state's pause
static void KoopaAttack_pause(KoopaAttack this, void* owner){}

// state's resume
static void KoopaAttack_resume(KoopaAttack this, void* owner){}


// state's on message
static u16 KoopaAttack_handleMessage(KoopaAttack this, void* owner, Telegram telegram);


/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 											CLASS'S DEFINITION
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */

__CLASS_DEFINITION(KoopaAttack, State);

/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												CLASS'S METHODS
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
__SINGLETON(KoopaAttack);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// class's constructor
static void KoopaAttack_constructor(KoopaAttack this){

	__STATE_CONSTRUCT(KoopaAttack, State);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// class's destructor
static void KoopaAttack_destructor(KoopaAttack this){
	
	
	// allow another creation of this state
	__SINGLETON_DESTRUCT;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's enter
static void KoopaAttack_enter(KoopaAttack this, void* owner){
	
	// do not move
	//Actor_stopMovement((Actor)owner);
	
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's execute
static void KoopaAttack_execute(KoopaAttack this, void* owner){
	
	if(MARIO_TIME_TO_DIE < Clock_getTime(_inGameClock) - Enemy_getActionTime((Enemy)owner)){
		
		// change state
		StateMachine_popState(Actor_getStateMachine((Actor)owner));
	}
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's exit 
static void KoopaAttack_exit(KoopaAttack this, void* owner){
	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's on message
static u16 KoopaAttack_handleMessage(KoopaAttack this, void* owner, Telegram telegram){

	return false;
}

