/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */



/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												INCLUDES
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */

#include "MarioStunned.h"
#include "MarioIdle.h"
#include "Mario.h"


/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												PROTOTYPES
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */


// class's constructor
static void MarioStunned_constructor(MarioStunned this);

// class's destructor
static void MarioStunned_destructor(MarioStunned this);

// state's enter
static void MarioStunned_enter(MarioStunned this, void* owner);

// state's execute
static void MarioStunned_execute(MarioStunned this, void* owner);

// state's exit
static void MarioStunned_exit(MarioStunned this, void* owner);

// state's pause
static void MarioStunned_pause(MarioStunned this, void* owner){}

// state's resume
static void MarioStunned_resume(MarioStunned this, void* owner){}


// state's on message
static u16 MarioStunned_handleMessage(MarioStunned this, void* owner, Telegram telegram);

/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 											CLASS'S DEFINITION
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */

__CLASS_DEFINITION(MarioStunned, State);

/* ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * 												CLASS'S METHODS
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 * ---------------------------------------------------------------------------------------------------------
 */
//////////////////////////////////////////////////////////////////////////////////////////////////////////////
__SINGLETON(MarioStunned);

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// class's constructor
static void MarioStunned_constructor(MarioStunned this){

	__STATE_CONSTRUCT(MarioStunned, State);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// class's destructor
static void MarioStunned_destructor(MarioStunned this){
	
	
	// allow another creation of this state
	__SINGLETON_DESTRUCT;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's enter
static void MarioStunned_enter(MarioStunned this, void* owner){

	
	//printText("Stunned" ,0 ,0);
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's execute
static void MarioStunned_execute(MarioStunned this, void* owner){
	
	
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's exit 
static void MarioStunned_exit(MarioStunned this, void* owner){
	
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////
// state's on message
static u16 MarioStunned_handleMessage(MarioStunned this, void* owner, Telegram telegram){


	return false;
}

