/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */
/*---------------------------------INCLUDES--------------------------------*/
#include <libgccvb.h>

#include <macros.h>
#include "chars.h"
#include "maps.h"


extern BYTE BACKMOUNT0_1_CH[];
extern BYTE BACKMOUNT0_2_CH[];

extern BYTE BACKMOUNT0_1_MP[];
extern BYTE BACKMOUNT0_2_MP[];


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition BACKMOUNT0_1_TX = {
		
		// Chargroup
		{
				// chDefinition,				 
				BACKMOUNT0_1_CH,	
				
				// numChars,
				32,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		BACKMOUNT0_1_MP,
		
		// cols (max 48)
		48,
		
		// rows (max 28)
		25,
		
		//pallet number,
		0
};


//////////////////////////////////////////////////////////////////////////////////////////////////////////////
TextureDefinition BACKMOUNT0_2_TX = {
		
		// Chargroup
		{
				// chDefinition,				 
				BACKMOUNT0_2_CH,	
				
				// numChars,
				56,
				
				// allocation type
				__NO_ANIMATED
		},
		
		// bgmap definition
		BACKMOUNT0_2_MP,
		
		// cols (max 48)
		48,
		
		// rows (max 28)
		25,
		
		//pallet number,
		0
};

ScrollDefinition BACKMOUNT0_SC = {
	{
		// object's class			   
		__TYPE(Scroll),  

		// Sprite
		{
			// the texture
			NULL,
			
			// bgmap mode ( BGMAP, AFFINE, H-BIAS)
			WRLD_BGMAP,
			
			// display mode
			WRLD_ON,
		},
	},
	{
		// Sprite
		{
			// the texture
			&BACKMOUNT0_1_TX,
			
			// bgmap mode ( BGMAP, AFFINE, H-BIAS)
			WRLD_BGMAP,
			
			// display mode
			WRLD_ON,
		},
		// Sprite
		{
			// the texture
			&BACKMOUNT0_2_TX,
			
			// bgmap mode ( BGMAP, AFFINE, H-BIAS)
			WRLD_BGMAP,
			
			// display mode
			WRLD_ON,
		},
	}
};