/* VbJaEngine: bitmap graphics engine for the Nintendo Virtual Boy 
 * 
 * Copyright (C) 2007 Jorge Eremiev
 * jorgech3@gmail.com
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef GAMEWORLDS_H_
#define GAMEWORLDS_H_

/*---------------------------------INCLUDES--------------------------------*/
#include <objects.h>
#include <macros.h>

/*---------------------------------ASSETS----------------------------------*/
/*---------------------------------ASSETS----------------------------------*/
/* If the world structure is altered, there are GameWorld's methods
 * which asume certain indexes for some attributes so check for those!
 */

StageDefinition PVBCC_WR = {
		// size
		{
				// x
				384,
				// y
				228,
				// z
				10
		},
		//initial screen position
		{
				// x
				0,
				// y
				0,
				//z
				__ZZERO
		},
		//background music
		NULL,
	
		//entities
		{
			
			{&PVBCC_LEFT_BG,{SCREEN_CENTER_X, SCREEN_CENTER_Y, 0}, NULL},
			{&PVBCC_RIGHT_BG,{SCREEN_CENTER_X, SCREEN_CENTER_Y, 0}, NULL},
			{NULL,{0,0,0}, NULL},
		},

};

StageDefinition PRECAUTION_WR = {
		// size
		{
				// x
				384,
				// y
				228,
				// z
				10
		},
		//initial screen position
		{
				// x
				0,
				// y
				0,
				//z
				__ZZERO
		},
		//background music
		NULL,
	
		//entities
		{
			{&PRECAUTION_BG, {SCREEN_CENTER_X, SCREEN_CENTER_Y, 0}, NULL},
			{NULL,{0,0,0}, NULL},
		},

};

StageDefinition FOCUS_WR = {
		
		// size
		{
				// x
				384,
				// y
				228,
				// z
				10
		},
		//initial screen position
		{
				// x
				0,
				// y
				0,
				//z
				__ZZERO
		},
		//background music
		NULL,

		//entities
		{
			
			{&PVB_LEFT_BG, {SCREEN_CENTER_X, SCREEN_CENTER_Y, 0}, NULL},
			{&PVB_RIGHT_BG, {SCREEN_CENTER_X, SCREEN_CENTER_Y, 0}, NULL},
			
			{NULL,{0,0,0}, NULL},
		},
};

StageDefinition VBJAE_WR = {
		// size
		{
				// x
				384,
				// y
				228,
				// z
				10
		},
		//initial screen position
		{
				// x
				0,
				// y
				0,
				//z
				__ZZERO
		},
		//background music
		NULL,
	
		//entities
		{
			{&VBJAE_LEFT_BG, {SCREEN_CENTER_X, SCREEN_CENTER_Y, 0}, NULL},
			{&VBJAE_RIGHT_BG, {SCREEN_CENTER_X, SCREEN_CENTER_Y, 0}, NULL},
			{NULL,{0,0,0}, NULL},
		},

};


StageDefinition TITLE_WR = {
		// size
		{
				// x
				384,
				// y
				228,
				// z
				100
		},
		//initial screen position
		{
				// x
				0,
				// y
				0,
				//z
				__ZZERO
		},
		//background music
		NULL,
	
		//entities
		{
			{&TITLE_BG, {SCREEN_CENTER_X, 50, 50}, NULL},
			{&MARIO_TITLE_LEFT_BG, {SCREEN_CENTER_X, SCREEN_CENTER_Y + 20, 0}, NULL},
			{&MARIO_TITLE_RIGHT_BG, {SCREEN_CENTER_X, SCREEN_CENTER_Y + 20, 0}, NULL},
			{NULL,{0,0,0}, NULL},
		},

};


StageDefinition WORLD_0_0_0 = {
		// size
		{
				// x
				1800,
				// y
				228,
				// z
				LAYER_4
		},
		//initial screen position
		{
				// x
				0,
				// y
				0,
				//z
				__ZZERO
		},
		
		//background music		
		WORLD_0_0_0_BGM,
		//NULL,

		//entities
		{
			{&BACKMOUNT0_SC, {20, 208, LAYER_3 + 1}, NULL},
			
			{&NORMALBLOCK_BG, {142, 130, LAYER_0+1}, NULL},
			
			{&MARIO_MC, {60, 170, LAYER_0}, NULL},
			
			{&FLOOR0_BG, {112, 208, LAYER_0}, NULL},
			
			//{NULL, {60, 170, LAYER_0}, NULL},
			{&MOUNTS0_BG, {144, 200, LAYER_1 +1}, NULL},			
			
			{&FLOOR1_BG, {308, 208, LAYER_0}, NULL},

			{&FLOOR0_BG, {502, 208, LAYER_0}, NULL},
			
			{&KOOPA0_MC,{560, 178, LAYER_0}, NULL},
			
			{&JAPANARC_BG, {564, 160, LAYER_0 +10}, NULL},

			{&BRIDGE_FAR_BG, {562, 187, LAYER_0 + 1}, NULL},
			
			{&TRANSPARENTBRIDGE_BG, {562, 187, (LAYER_0 + 10 + LAYER_2 - 10) / 5 }, NULL},
			{&TRANSPARENTBRIDGE_BG, {562, 187, (LAYER_0 + 10 + LAYER_2 - 10) / 5 * 2}, NULL},
			{&TRANSPARENTBRIDGE_BG, {562, 187, (LAYER_0 + 10 + LAYER_2 - 10) / 5 * 3}, NULL},
			{&TRANSPARENTBRIDGE_BG, {562, 187, (LAYER_0 + 10 + LAYER_2 - 10) / 5 * 4}, NULL},
			
			{&BRIDGE_NEAR_BG, {562, 187, LAYER_2 - 1}, NULL},
			
			{&PIPE0_BG, {762, 186, LAYER_2 + 1}, NULL},
			{&FLOOR0_BG, {654, 208, LAYER_2}, NULL},
			
			{&FLOOR1_BG, {776, 208, LAYER_1}, NULL},
			{&KOOPA0_MC,{772, 160, LAYER_1}, NULL},
			
			{&FLOOR0_BG, {862, 213, LAYER_0}, NULL},

			{&PIPE0_BG, {962, 188, LAYER_0 + 2}, NULL},
			{&PIRANHA_PLANT_V_MC, {962, 188 - 8, LAYER_0 + 3}, NULL},
			
			{&WALL0_BG, {962, 172, LAYER_1}, NULL},
			{&KOOPA0_MC,{962 - 8, 168 - 24, LAYER_1 + 1}, NULL},
			{&FLOOR2_BG, {992, 178 - 8, LAYER_2}, NULL},
			
			{&FLOOR0_BG, {1292, 208, LAYER_2}, NULL},
			{&NORMALBLOCK_BG, {1320, 148, LAYER_2}, NULL},
			{&PIPE1_BG, {1320, 170, LAYER_1 + 1}, NULL},
			
			{&PIPE0_BG, {1390, 188, LAYER_1 + 1}, NULL},
			{&PIRANHA_PLANT_V_MC, {1390 - 1, 188 - 7, LAYER_1 + 3}, NULL},

			{&FLOOR1_BG, {1470, 208, LAYER_1}, NULL},
			{&FLOOR0_BG, {1690, 208, LAYER_1}, NULL},

			{&GOAL0_BG, {1730, 90, LAYER_1 + 40}, NULL},
			{&POLE0_BG, {1632, 130, LAYER_1 + 2}, NULL},
			
			{&TRANSPARENTBRIDGE_BG, {1730, 186, LAYER_1 + 10}, NULL},
			{&TRANSPARENTBRIDGE_BG, {1730, 186, LAYER_1 + 20}, NULL},
			{&TRANSPARENTBRIDGE_BG, {1730, 186, LAYER_1 + 30}, NULL},
			{&GATE_BG, {1730 +16, 188, LAYER_1}, NULL},
			
			
			{NULL,{0,0,0}, NULL},
		},

};

/*
StageDefinition CREDITS_WR = {
		//xSize,ySize,zSize,
		{384,228,0,},
		//initial screen position x,y,z,
		{0,0,__ZZERO,},
		//background music
		NULL,

		//list of objects
		//characters
		{
			{NULL,{0,0,0},false}
		},
		//scrolls
		{
			{NULL,{0,0,0}}
		},
		//backgrounds
		{
			{NULL,{0,0,0}}
		},
		//texboxes
		{
			{NULL,{0,0,0},false,}
		},
		
};


StageDefinition PAUSESCREEN_WR = {
		//xSize,ySize,zSize,
		{384,228,0,},
		//initial screen position x,y,z,
		{0,0,__ZZERO,},
		//background music
		NULL,

		//list of objects
		//characters
		{
			{NULL,{0,0,0},false}
		},
		//scrolls
		{
			{NULL,{0,0,0}}
		},
		//backgrounds
		{
			{NULL,{0,0,0}}
		},
		//texboxes
		{
			{&PAUSE_TX,{21*8+4,24,__ZZERO},false,},
			
			{&QUIT_TX,{22*8,18*8,__ZZERO+40},true,},
			{&RESUME_TX,{21*8,14*8,__ZZERO+40},true,},
			{NULL,{0, 0, 0},false,},
		},
};


StageDefinition RESTSCREEN_WR = {
		//xSize,ySize,zSize,
		{384,228,0,},
		//initial screen position x,y,z,
		{0,0,__ZZERO,},
		//background music
		NULL,

		//list of objects
		//characters
		{
			{NULL,{0,0,0},false}
		},
		//scrolls
		{
			{NULL,{0,0,0}}
		},
		//backgrounds
		{
			{NULL,{0,0,0}}
		},
		//texboxes
		{
			{&REST_TX,{16*8,24,__ZZERO-40},false,},
			{NULL,{0, 0, 0},false,},
		},

};



StageDefinition AUTOPAUSESCREEN_WR = {
		//xSize,ySize,zSize,
		{384,228,0,},
		//initial screen position x,y,z,
		{0,0,__ZZERO,},
		//background music
		NULL,

		//list of objects
		//characters
		{
			{NULL,{0,0,0},false}
		},
		//scrolls
		{
			{NULL,{0,0,0}}
		},
		//backgrounds
		{
			{NULL,{0,0,0}}
		},
		//texboxes
		{
			{&AUTOPAUSE_TX,{16*8,4*8,__ZZERO},false},
			{&YES_TX,{23*8-4,15*8,__ZZERO+40},true},
			{&NO_TX,{23*8,17*8,__ZZERO+40},true},
			{NULL,{0, 0, 0},false,},
		},

};


StageDefinition WORLD_0_0_WR = {
	//Size x,y,z
	{10000,228,300,},
	//initial screen position x,y,z,
	{0,0,__ZZERO,},
	//background music
	//JORGECHE_BGM,
	NULL,

	//list of objects
	//characters
	{
		{&MARIO_MC, {20, __FLOOR-8*6, LAYER1}, true},
		//{NULL,{0,0,0},false},
		{&KOOPA0_MC, {42*8, __FLOOR-8*3, LAYER1}, false},
		{&KOOPA0_MC, {62*8, __FLOOR-8*3, LAYER1}, false},
		{NULL,{0,0,0},false}
		
			
		//{&PIRANHAFLOWER0_MC,{16*8-1,__FLOOR-8*3+1,LAYER1+2},false},
		
		{&INTERROGATIONBLOCKCOIN_MC,{147,__FLOOR-8*8-4,LAYER1},false},
		{&INTERROGATIONBLOCKCOIN_MC,{164,__FLOOR-8*8-4,LAYER1},false},
		{&INTERROGATIONBLOCKCOIN_MC,{180,__FLOOR-8*8-4,LAYER1},false},
		{&KOOPA0_MC,{42*8,__FLOOR-8*3,LAYER1},false},
		{&KOOPA0_MC,{95*8,	__FLOOR-8*5,LAYER2},false},
		{&INTERROGATIONBLOCKFIRE_MC,{55*8,__FLOOR-8*2+1,LAYER1},false},
		{&PIRANHAFLOWER0_MC,{66*8-1,__FLOOR-8*2+1,LAYER1+2},false},
		{&PIRANHAFLOWER0_MC,{116*8-1,__FLOOR-8*3-2,LAYER2+2},false},
		{&INTERROGATIONBLOCKCOIN_MC,{120*8,__FLOOR-8*8,LAYER2},false},
		{&INTERROGATIONBLOCKCOIN_MC,{122*8+1,__FLOOR-8*8,LAYER2},false},
		{&INTERROGATIONBLOCKCOIN_MC,{124*8+2,__FLOOR-8*8,LAYER2},false},
		{&COINFLOAT_MC,{301*8,__FLOOR-8*10,LAYER1},false},
		{&COINFLOAT_MC,{303*8+1,__FLOOR-8*10,LAYER1},false},
		{&COINFLOAT_MC,{305*8+2,__FLOOR-8*10,LAYER1},false},
		*/
/*
	},
	//scrolls
	{
		
		//{&BACKMOUNT0_SC,{0,0,300}},
		{NULL,{0,0,300}},
		
	},
	//backgrounds
	{

		{&FLOOR0_BG,{0,__FLOOR-8*1,LAYER1-1}},
		
		
		{&PIPE0_BG,{36*8,__FLOOR-8*4+4,LAYER1+1}},
		
		{&FLOOR1_BG,{35*8,__FLOOR,LAYER1-1}},
		//{NULL, {0, 0, 0}},
		{&WALL0_BG,{14*8,__FLOOR-8*12,LAYER1+1}},
		
		{&WALL0_BG,{48*8,__FLOOR-8*3,LAYER1+1}},
		{&MOUNTS1_BG,{40*8,__FLOOR-8*4,LAYER1+70}},
		{&PIPE0_BG,{65*8,__FLOOR-8*2,LAYER1+1}},
		{&JAPANARC_BG,{75*8,__FLOOR-8*11,LAYER1+20}},
		{&BRIDGE0_BG,{80*8,__FLOOR-8*2+4,LAYER1+1}},
		{&TRANSPARENTBRIDGE_BG,{80*8,__FLOOR-8*2+4,LAYER1+40}},
		{&TRANSPARENTBRIDGE_BG,{80*8,__FLOOR-8*2+4,LAYER1+80}},
		{&TRANSPARENTBRIDGE_BG,{80*8,__FLOOR-8*2+4,LAYER1+120}},
		{&TRANSPARENTBRIDGE_BG,{80*8,__FLOOR-8*2+4,LAYER1+160}},
		{&BRIDGE0_BG,{80*8,__FLOOR-8*2+4,LAYER2-1}},
		{&FLOOR1_BG,{79*8,__FLOOR,LAYER2-1}},
		{&MOUNTS0_BG,{105*8,__FLOOR-8*4,LAYER2+50}},
		{&PIPE0_BG,{115*8,__FLOOR-8*4+4,LAYER2+1}},
		{&BRIDGE0_BG,{148*8,__FLOOR-8*2+4,LAYER1+1}},
		{&TRANSPARENTBRIDGE_BG,{148*8,__FLOOR-8*2+4,LAYER1+40}},
		{&TRANSPARENTBRIDGE_BG,{148*8,__FLOOR-8*2+4,LAYER1+80}},
		{&TRANSPARENTBRIDGE_BG,{148*8,__FLOOR-8*2+4,LAYER1+120}},
		{&TRANSPARENTBRIDGE_BG,{148*8,__FLOOR-8*2+4,LAYER1+160}},
		{&BRIDGE0_BG,{148*8,__FLOOR-8*2+4,LAYER2-1}},
		{&FLOOR1_BG,{143*8,__FLOOR,LAYER1-1}},
		{&FLOOR2_BG,{202*8,__FLOOR-8*4,LAYER1+1}},
		{&FLOOR2_BG,{214*8,__FLOOR-8*8,LAYER1+2}},
		{&NORMALBLOCK_BG,{302*8,__FLOOR-8*4,LAYER1}},
		{&NORMALBLOCK_BG,{304*8,__FLOOR-8*4,LAYER1}},
		{&FLOOR1_BG,{232*8,__FLOOR,LAYER1}},
		{&PIPE1_BG,{262*8,__FLOOR-8*4,LAYER1}},
		{&GOAL0_BG,{350*8,__FLOOR-8*24,LAYER1+10}},
		{&FLOOR1_BG,{315*8,__FLOOR,LAYER1}},
		{&POLE0_BG,{345*8,__FLOOR-8*12,LAYER1+2}},
		{NULL, {0, 0, 0}},
	},
	{
		{NULL,{0, 0, 0},false,},
		{&MARIO_TX,{12*8,20,200},false},
		{&JORGE_TX,{12*8,40,200},false},
		{&ESPE_TX,{15*8,60,200},false},
		{NULL,{0, 0, 0},false,},
	},
	
};
*/


#endif /*GAMEWORLD_H_*/
